Subject: [AVTCORE] Adam Roach's Discuss on draft-ietf-payload-rtp-ttml-03: (with DISCUSS and COMMENT)

From: Adam Roach via Datatracker <[email-masked]>
Date: Tue, 15 Oct 2019 22:55:37 -0700

Adam Roach has entered the following ballot position for
draft-ietf-payload-rtp-ttml-03: Discuss

When responding, please keep the subject line intact and reply to all
email addresses included in the To and CC lines. (Feel free to cut this
introductory paragraph, however.)

Please refer to https://www.ietf.org/iesg/statement/discuss-criteria.html
for more information about IESG DISCUSS and COMMENT positions.

The document, along with other ballot positions, can be found here:
https://datatracker.ietf.org/doc/draft-ietf-payload-rtp-ttml/

----------------------------------------------------------------------
DISCUSS:
----------------------------------------------------------------------

Thanks for the work everyone put into this document. I think it's not quite
ready to publish, due to one ambiguity, one critical missing feature,
and the lack of guidance around fragmentation. I also have two comments that I
consider very important, although they don't quite rise to the level of blocking
publication.

As always, it's possible that my DISCUSS points are off-base, and I'd be
happy to be corrected if I've misunderstood anything here.

---------------------------------------------------------------------------

§4.1:

>     When the document spans more
>     than one RTP packet, the entire document is obtained by
>     concatenating User Data Words from each contributing packet in
>     ascending order of Sequence Number.

This is underspecified, in that it doesn't make it clear whether it would be
valid to split a single UTF-8 or UTF-16 character between RTP packets, and it
is nearly certain that different implementations will make different
assumptions on this point, leading to interop failures. For example, the UTF-8
encoding of '¢' is 0xC2 0xA2. Would it be valid to place the "0xC2" in one
packet and the "0xA2" in a subsequent packet?

Without specifying this, it is quite likely that some implementations will
use, e.g., UTF-8 strings to accumulate the contents of RTP packets; and most
such libraries will emit errors or exhibit unexpected behavior if units of
less than a character are added at any time.  (The same point holds for
splitting a UTF-16 byte across packets).

I don't think it much matters which choice you make (explicitly allowing
or explicitly forbidding splitting characters between packets), but it
does need to be explicit. I have a slight personal preference for requiring
that characters cannot be split (both for ease of implementation on the
receiving end and to more smoothly handle missing data due to extended packet
loss), but leave it to the authors and working group to decide.

---------------------------------------------------------------------------

Unlike other definitions to convey non-loss-resilient data on RTP streams, this
document had no defined mechanism to deal with packet loss. This makes it
unusable on the public Internet, where packet loss is an inevitable feature
of the network. The existing text-in-RTP specifications define procedures to
deal with such loss (see, e.g., RFC 4103 section 4 and RFC 4396 section 5).

---------------------------------------------------------------------------

This format is rather unique in that it, alone among all other RTP text
formats, is designed to send monolithic documents that may stretch into the
multiple kilobyte range.  While fragmentation is mentioned as a possibility,
the document provides no implementation guidance about when to fragment
documents, and what sizes each fragment should assume. RFC 4396 section 4.4 is
an example of the kind of information I would expect to see in a document like
this, with emphasis on the fact that TTML documents are going to frequently
exceed the PTMU for a typical network connection.

----------------------------------------------------------------------
COMMENT:
----------------------------------------------------------------------

§1:

>  TTML (Timed Text Markup Language)[TTML2] is a media type for
>  describing timed text such as closed captions (also known as
>  subtitles) in television workflows or broadcasts as XML.

Although superficially similar, there are important distinctions between
subtitles (intended to help a hearing audience exclusively with spoken dialog,
typically because the audio is in a different language or otherwise difficult to
understand) and closed captions (intended to aid deaf or hard-of-hearing
viewers by providing a direct, word-for-word transcription of dialog as well
as descriptions of all other audio present). Calling one "also known as" the
other is incorrect.

I suggest rephrasing as:

   TTML (Timed Text Markup Language)[TTML2] is a media type for
   describing timed text such as closed captions and subtitles
   in television workflows or broadcasts as XML.

---------------------------------------------------------------------------

§4.2.1.1:

>  The TTML document instance MUST use the "media" value of the
>  "ttp:timeBase" parameter attribute on the root element.

This statement makes an assumption that the
"http://www.w3.org/ns/ttml#parameter" namespace MUST be mapped to the "ttp"
prefix, which is both bad form and probably not what is intended. I suggest
rephrasing as:

   The TTML document instance MUST include a "timeBase" element from
   the "http://www.w3.org/ns/ttml#parameter" namespace containing
   the value "media".

---

From: James Sandford <[email-masked]>
Date: Wed, 16 Oct 2019 12:44:57 +0000

Responses in-line.

Regards,
James

Thanks for highlighting this. I also have a slight preference for not splitting characters.

I think RFC 4396 Section 5 could be adapted for our purposes. The main issue is the TTML payload document currently makes use of the Sequence Number to identify the order of document fragments. A re-transmitted fragment would have a different Sequence Number so there would be no way to match equivalent packets. A potential solution is to use the 16 Reserved bits for a new counter that performs the task of identifying fragment order.

How would this affect the progress of this document? While it represents a major change to the layout of the payload, the mechanisms used will be identical.

I would not be opposed to an equivalent section to this. I'll work on adapting the referenced section.

This isn't strictly true. At least in the UK, the term subtitles is used as a catch-all term to describe both translation subtitles/those to support unintelligible speech, and subtitles for the deaf and hard of hearing. That said, I have no objection to the alternative wording.

I have spoken to Nigel Megitt (chair of the W3C Timed Text Working Group) about this. He noted that "timeBase" is an attribute not an element. The following alternative is verbose but unambiguous:

    The TTML document instance's root "tt" element in the "http://www.w3.org/ns/ttml" namespace MUST include a "timeBase" attribute in the "http://www.w3.org/ns/ttml#parameter" namespace containing the value "media".

---

From: "Roni Even (A)" <[email-masked]>
Date: Wed, 16 Oct 2019 13:18:58 +0000

Hi James,
About packet loss, If the intention is to use retransmission look at RFC4588, it encapsulate the original RTP so no need for changes in ttml. You just need to signal support in the SDP.

Roni Even

-----Original Message-----
From: James Sandford [mailto:[email-masked]] 
Sent: Wednesday, October 16, 2019 3:45 PM
To: Adam Roach; The IESG
Cc: [email-masked]; Roni Even (A); [email-masked]; [email-masked]
Subject: RE: Adam Roach's Discuss on draft-ietf-payload-rtp-ttml-03: (with DISCUSS and COMMENT)

Responses in-line.

Regards,
James

>Thanks for the work everyone put into this document. I think it's not 
>quite ready to publish, due to one ambiguity, one critical missing 
>feature, and the lack of guidance around fragmentation. I also have two 
>comments that I consider very important, although they don't quite rise 
>to the level of blocking publication.
>
>As always, it's possible that my DISCUSS points are off-base, and I'd 
>be happy to be corrected if I've misunderstood anything here.
>
>This is underspecified, in that it doesn't make it clear whether it 
>would be valid to split a single UTF-8 or UTF-16 character between RTP 
>packets, and it is nearly certain that different implementations will 
>make different assumptions on this point, leading to interop failures. 
>For example, the UTF-8 encoding of '¢' is 0xC2 0xA2. Would it be valid 
>to place the "0xC2" in one packet and the "0xA2" in a subsequent packet?
>
>Without specifying this, it is quite likely that some implementations 
>will use, e.g., UTF-8 strings to accumulate the contents of RTP 
>packets; and most such libraries will emit errors or exhibit unexpected 
>behavior if units of less than a character are added at any time.  (The 
>same point holds for splitting a UTF-16 byte across packets).
>
>I don't think it much matters which choice you make (explicitly 
>allowing or explicitly forbidding splitting characters between 
>packets), but it does need to be explicit. I have a slight personal 
>preference for requiring that characters cannot be split (both for ease 
>of implementation on the receiving end and to more smoothly handle 
>missing data due to extended packet loss), but leave it to the authors and working group to decide.

>Unlike other definitions to convey non-loss-resilient data on RTP 
>streams, this document had no defined mechanism to deal with packet 
>loss. This makes it unusable on the public Internet, where packet loss 
>is an inevitable feature of the network. The existing text-in-RTP 
>specifications define procedures to deal with such loss (see, e.g., RFC 4103 section 4 and RFC 4396 section 5).

>formats, is designed to send monolithic documents that may stretch into 
>the multiple kilobyte range.  While fragmentation is mentioned as a 
>possibility, the document provides no implementation guidance about 
>when to fragment documents, and what sizes each fragment should assume. 
>RFC 4396 section 4.4 is an example of the kind of information I would 
>expect to see in a document like this, with emphasis on the fact that 
>TTML documents are going to frequently exceed the PTMU for a typical network connection.

>Although superficially similar, there are important distinctions 
>between subtitles (intended to help a hearing audience exclusively with 
>spoken dialog, typically because the audio is in a different language 
>or otherwise difficult to
>understand) and closed captions (intended to aid deaf or 
>hard-of-hearing viewers by providing a direct, word-for-word 
>transcription of dialog as well as descriptions of all other audio 
>present). Calling one "also known as" the other is incorrect.
>
>I suggest rephrasing as:
>

>prefix, which is both bad form and probably not what is intended. I 
>suggest rephrasing as:
>

---

From: "Roni Even (A)" <[email-masked]>
Date: Wed, 16 Oct 2019 13:20:22 +0000

James,
The OSN is the original sequence number
Roni

-----Original Message-----
From: Roni Even (A) 
Sent: Wednesday, October 16, 2019 4:19 PM
To: 'James Sandford'; Adam Roach; The IESG
Cc: [email-masked]; [email-masked]; [email-masked]
Subject: RE: Adam Roach's Discuss on draft-ietf-payload-rtp-ttml-03: (with DISCUSS and COMMENT)

Hi James,

Roni Even

-----Original Message-----
From: James Sandford [mailto:[email-masked]]
Sent: Wednesday, October 16, 2019 3:45 PM
To: Adam Roach; The IESG
Cc: [email-masked]; Roni Even (A); [email-masked]; [email-masked]
Subject: RE: Adam Roach's Discuss on draft-ietf-payload-rtp-ttml-03: (with DISCUSS and COMMENT)

Responses in-line.

Regards,
James

---

From: James Sandford <[email-masked]>
Date: Wed, 16 Oct 2019 13:22:54 +0000

Doesn't RFC4588 require RTCP? That might be a bit over the top for a minimal implementation. RFC 4396 references RFC4588 (all be it in a draft state) while also providing a basic uni-directional re-transmission scheme as the default.

==========
James Sandford
R&D Project Engineer

BBC Research and Development
5th Floor
Dock House
MediaCityUK
Salford
M50 2LH

Tel: 030304 (09549)
Web: http://www.bbc.co.uk/rd

________________________________________
From: Roni Even (A) [[email-masked]]
Sent: 16 October 2019 14:18
To: James Sandford; Adam Roach; The IESG
Cc: [email-masked]; [email-masked]; [email-masked]
Subject: RE: Adam Roach's Discuss on draft-ietf-payload-rtp-ttml-03: (with DISCUSS and COMMENT)

Hi James,

Roni Even

-----Original Message-----
From: James Sandford [mailto:[email-masked]]
Sent: Wednesday, October 16, 2019 3:45 PM
To: Adam Roach; The IESG
Cc: [email-masked]; Roni Even (A); [email-masked]; [email-masked]
Subject: RE: Adam Roach's Discuss on draft-ietf-payload-rtp-ttml-03: (with DISCUSS and COMMENT)

Responses in-line.

Regards,
James

---

From: "Roni Even (A)" <[email-masked]>
Date: Wed, 16 Oct 2019 13:42:08 +0000

Hi James,
RTCP is mandatory for RTP, in the case of packet loss how will you ask for retransmission since RTP is unidirectional.  I did not see that RFC4396 mention uni-directional re-transmission.
If you are not using retransmission, packet loss will require FEC or redundancy , so you will need to specify how to use them.
For redundancy look at RFC4103 for addressing the sequence number  and RFC2198

Roni Even

-----Original Message-----
From: James Sandford [mailto:[email-masked]] 
Sent: Wednesday, October 16, 2019 4:23 PM
To: Roni Even (A); Adam Roach; The IESG
Cc: [email-masked]; [email-masked]; [email-masked]
Subject: RE: Adam Roach's Discuss on draft-ietf-payload-rtp-ttml-03: (with DISCUSS and COMMENT)

==========
James Sandford
R&D Project Engineer

Tel: 030304 (09549)

Hi James,

Roni Even

-----Original Message-----
From: James Sandford [mailto:[email-masked]]
Sent: Wednesday, October 16, 2019 3:45 PM
To: Adam Roach; The IESG
Cc: [email-masked]; Roni Even (A); [email-masked]; [email-masked]
Subject: RE: Adam Roach's Discuss on draft-ietf-payload-rtp-ttml-03: (with DISCUSS and COMMENT)

Responses in-line.

Regards,
James

---

From: James Sandford <[email-masked]>
Date: Wed, 16 Oct 2019 13:51:26 +0000

Sorry. I think I am mixing terms here. RFC 4396 specifies redundant transmission by default. 

You are right that the RFC4103 method will work in our case with minimal changes.

==========
James Sandford
R&D Project Engineer

Tel: 030304 (09549)

Sent: 16 October 2019 14:42

Hi James,

Roni Even

-----Original Message-----
From: James Sandford [mailto:[email-masked]]
Sent: Wednesday, October 16, 2019 4:23 PM
To: Roni Even (A); Adam Roach; The IESG
Cc: [email-masked]; [email-masked]; [email-masked]
Subject: RE: Adam Roach's Discuss on draft-ietf-payload-rtp-ttml-03: (with DISCUSS and COMMENT)

==========
James Sandford
R&D Project Engineer

Tel: 030304 (09549)

Hi James,

Roni Even

-----Original Message-----
From: James Sandford [mailto:[email-masked]]
Sent: Wednesday, October 16, 2019 3:45 PM
To: Adam Roach; The IESG
Cc: [email-masked]; Roni Even (A); [email-masked]; [email-masked]
Subject: RE: Adam Roach's Discuss on draft-ietf-payload-rtp-ttml-03: (with DISCUSS and COMMENT)

Responses in-line.

Regards,
James